

# DescribeDetectorModel
<a name="API_DescribeDetectorModel"></a>

**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Describes a detector model. If the `version` parameter is not specified, information about the latest version is returned.

## Request Syntax
<a name="API_DescribeDetectorModel_RequestSyntax"></a>

```
GET /detector-models/detectorModelName?version=detectorModelVersion HTTP/1.1
```

## URI Request Parameters
<a name="API_DescribeDetectorModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [detectorModelName](#API_DescribeDetectorModel_RequestSyntax) **   <a name="iotevents-DescribeDetectorModel-request-uri-detectorModelName"></a>
The name of the detector model.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `^[a-zA-Z0-9_-]+$`   
Required: Yes

 ** [detectorModelVersion](#API_DescribeDetectorModel_RequestSyntax) **   <a name="iotevents-DescribeDetectorModel-request-uri-detectorModelVersion"></a>
The version of the detector model.  
Length Constraints: Minimum length of 1. Maximum length of 128.

## Request Body
<a name="API_DescribeDetectorModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_DescribeDetectorModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "detectorModel": { 
      "detectorModelConfiguration": { 
         "creationTime": number,
         "detectorModelArn": "string",
         "detectorModelDescription": "string",
         "detectorModelName": "string",
         "detectorModelVersion": "string",
         "evaluationMethod": "string",
         "key": "string",
         "lastUpdateTime": number,
         "roleArn": "string",
         "status": "string"
      },
      "detectorModelDefinition": { 
         "initialStateName": "string",
         "states": [ 
            { 
               "onEnter": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ]
               },
               "onExit": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ]
               },
               "onInput": { 
                  "events": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string"
                     }
                  ],
                  "transitionEvents": [ 
                     { 
                        "actions": [ 
                           { 
                              "clearTimer": { 
                                 "timerName": "string"
                              },
                              "dynamoDB": { 
                                 "hashKeyField": "string",
                                 "hashKeyType": "string",
                                 "hashKeyValue": "string",
                                 "operation": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "payloadField": "string",
                                 "rangeKeyField": "string",
                                 "rangeKeyType": "string",
                                 "rangeKeyValue": "string",
                                 "tableName": "string"
                              },
                              "dynamoDBv2": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "tableName": "string"
                              },
                              "firehose": { 
                                 "deliveryStreamName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "separator": "string"
                              },
                              "iotEvents": { 
                                 "inputName": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "iotSiteWise": { 
                                 "assetId": "string",
                                 "entryId": "string",
                                 "propertyAlias": "string",
                                 "propertyId": "string",
                                 "propertyValue": { 
                                    "quality": "string",
                                    "timestamp": { 
                                       "offsetInNanos": "string",
                                       "timeInSeconds": "string"
                                    },
                                    "value": { 
                                       "booleanValue": "string",
                                       "doubleValue": "string",
                                       "integerValue": "string",
                                       "stringValue": "string"
                                    }
                                 }
                              },
                              "iotTopicPublish": { 
                                 "mqttTopic": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "lambda": { 
                                 "functionArn": "string",
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 }
                              },
                              "resetTimer": { 
                                 "timerName": "string"
                              },
                              "setTimer": { 
                                 "durationExpression": "string",
                                 "seconds": number,
                                 "timerName": "string"
                              },
                              "setVariable": { 
                                 "value": "string",
                                 "variableName": "string"
                              },
                              "sns": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "targetArn": "string"
                              },
                              "sqs": { 
                                 "payload": { 
                                    "contentExpression": "string",
                                    "type": "string"
                                 },
                                 "queueUrl": "string",
                                 "useBase64": boolean
                              }
                           }
                        ],
                        "condition": "string",
                        "eventName": "string",
                        "nextState": "string"
                     }
                  ]
               },
               "stateName": "string"
            }
         ]
      }
   }
}
```

## Response Elements
<a name="API_DescribeDetectorModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [detectorModel](#API_DescribeDetectorModel_ResponseSyntax) **   <a name="iotevents-DescribeDetectorModel-response-detectorModel"></a>
Information about the detector model.  
Type: [DetectorModel](API_DetectorModel.md) object

## Errors
<a name="API_DescribeDetectorModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ResourceNotFoundException **   
The resource was not found.    
 ** message **   
The message for the exception.
HTTP Status Code: 404

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_DescribeDetectorModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-2018-07-27/DescribeDetectorModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-2018-07-27/DescribeDetectorModel) 